<script setup lang="ts">
  import { useVuelidate } from '@vuelidate/core';
  import { required, email, minLength, requiredIf } from '@vuelidate/validators';
  import { ShopwareError } from '@shopware-pwa/types';

  const emits = defineEmits<{
    (e: 'success'): void;
    (e: 'open-login-modal'): void;
  }>();

  defineProps<{
    registerErrors?: ShopwareError[];
  }>();

  const state = reactive({
    email: '',
    password: '',
    isCreateNewAccount: true,
  });

  const rules = computed(() => ({
    email: {
      required,
      email,
    },
    password: {
      required: requiredIf(() => {
        return state.isCreateNewAccount;
      }),
      minLength: minLength(8),
    },
  }));

  const $v = useVuelidate(rules, state);

  const validate = async () => {
    $v.value.$touch();
    return await $v.value.$validate();
  };

  defineExpose({ state, validate });
</script>

<template>
  <div class="flex flex-col space-y-6">
    <div v-if="registerErrors?.length">
      <SwBanner
        v-for="error in registerErrors"
        :key="error.detail"
        class="mt-3"
        variant="error"
        :show-close-btn="false"
      >
        {{ error.detail }}
      </SwBanner>
    </div>
    <!-- Account basic information -->
    <div
      class="bg-background-raised text-(sm/6 information) mt-6 flex justify-center rounded-md px-4 py-3.5 font-medium"
    >
      <span>{{ $t('alreadyHaveAccount') }}</span>
      <SwLink class="pl-1" @click="emits('open-login-modal')">
        {{ $t('account.logIn') }}
      </SwLink>
    </div>
    <div>
      <SwTextField
        id="email"
        v-model="state.email"
        :placeholder="$t('loginForm.emailPlaceholder')"
        name="email-address"
        type="email"
        size="large"
        :errors="$v.email.$errors"
        :label="$t('emailAddress')"
        @blur="$v.email.$touch"
      />
    </div>
    <div>
      <SwCheckbox v-model="state.isCreateNewAccount">
        <template #label>
          <span class="text-sm/6 font-semibold">
            {{ $t('createAnAccount') }}
          </span>
        </template>
      </SwCheckbox>
    </div>
    <div v-if="state.isCreateNewAccount">
      <SwTextField
        id="password"
        v-model="state.password"
        :placeholder="$t('createAccountForm.passwordPlaceholder')"
        name="password"
        type="password"
        size="large"
        :errors="$v.password.$errors"
        :label="$t('password')"
        @blur="$v.password.$touch"
      />
    </div>
  </div>
</template>
